from keystone import *
import struct

print("Compatible only with version 1.1.1!")
choice = int(input("What version (write number):\n[0] Western (0100B04011742000)\n[1] Japanese (0100559011740000):\n"))

if (choice > 1):
    print ("Write 0 or 1!")
    exit()

Height = int(input("Write height of resolution you want to use:\n"))

if (Height > 1080):
    print ("Height cannot be bigger than 1080!")
    exit()
    
if (Height <= 0):
    print ("Height cannot be equal or lower than 0!")
    exit()


Ratio = Height / 1080
Ratio_byted = bytearray(struct.pack("!f", Ratio))  

Instructions = b"MOVK x9, #0x%x%x, lsl#32; MOVK x9, #0x%x%x, lsl#48" % (Ratio_byted[2], Ratio_byted[3], Ratio_byted[0], Ratio_byted[1])

ks = Ks(KS_ARCH_ARM64, KS_MODE_LITTLE_ENDIAN)
encoding, count = ks.asm(Instructions)

if (choice == 0): f = open("6CDEC176EA1D12C5C4F85BF17213377C22D1EEEF000000000000000000000000.ips", "wb")
elif (choice == 1): f = open("1FEFBA03B2BD13A991B22244B43E06BC62F4D1F7000000000000000000000000.ips", "wb")
else:
    print ("Unknown error!")
    exit() 
f.write(b"PATCH")
if (choice == 0): f.write(b"\x55\x7b\xfc")
elif (choice == 1): f.write(b"\x55\x7c\x00")

f.write(b"\x00\x08")
for i in range(0, 8):
    f.write(encoding[i].to_bytes(1, byteorder='little'))
f.write(b"EOF")
f.close()

if (choice == 0): print("Created 6CDEC176EA1D12C5C4F85BF17213377C22D1EEEF000000000000000000000000.ips")
elif (choice == 1): print("Created 1FEFBA03B2BD13A991B22244B43E06BC62F4D1F7000000000000000000000000.ips")